'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var reactNative = require('react-native');
var _inheritsLoose = _interopDefault(require('@babel/runtime/helpers/inheritsLoose'));
var shared = require('@react-spring/shared');
var animated$1 = require('@react-spring/animated/index.cjs.js');
var stringInterpolation = require('@react-spring/shared/stringInterpolation');
var colorNames = _interopDefault(require('@react-spring/shared/colors'));
var core = require('@react-spring/core/index.cjs.js');

var AnimatedTransform =
/*#__PURE__*/
function (_AnimatedObject) {
  _inheritsLoose(AnimatedTransform, _AnimatedObject);

  function AnimatedTransform(source) {
    return _AnimatedObject.call(this, source) || this;
  }

  var _proto = AnimatedTransform.prototype;

  _proto.getValue = function getValue() {
    return this.source ? this.source.map(function (source) {
      var transform = {};
      shared.each(source, function (source, key) {
        transform[key] = shared.getFluidValue(source);
      });
      return transform;
    }) : [];
  };

  _proto.setValue = function setValue(source) {
    this.source = source;
    this.payload = this._makePayload(source);
  };

  _proto._makePayload = function _makePayload(source) {
    var _this = this;

    if (!source) return [];
    var payload = new Set();
    shared.each(source, function (transform) {
      return shared.each(transform, _this._addToPayload, payload);
    });
    return Array.from(payload);
  };

  return AnimatedTransform;
}(animated$1.AnimatedObject);

var elements = {
  View: reactNative.View,
  Text: reactNative.Text,
  Image: reactNative.Image
};
var animated = animated$1.extendAnimated(animated$1.withAnimated, Object.values(elements));

shared.Globals.assign({
  defaultElement: reactNative.View,
  colorNames: colorNames,
  createStringInterpolator: stringInterpolation.createStringInterpolator,
  applyAnimatedValues: function applyAnimatedValues(instance, props) {
    return instance.setNativeProps ? instance.setNativeProps(props) : false;
  },
  createAnimatedTransform: function createAnimatedTransform(transform) {
    return new AnimatedTransform(transform);
  },
  createAnimatedStyle: function createAnimatedStyle(styles) {
    styles = reactNative.StyleSheet.flatten(styles);

    if (shared.is.obj(styles.shadowOffset)) {
      styles.shadowOffset = new animated$1.AnimatedObject(styles.shadowOffset);
    }

    return new animated$1.AnimatedStyle(styles);
  }
});

Object.keys(core).forEach(function (k) {
  if (k !== 'default') Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () {
      return core[k];
    }
  });
});
exports.a = animated;
exports.animated = animated;
//# sourceMappingURL=index.cjs.js.map
