import { View, StyleSheet } from 'react-native'
import { AnimatedTransform } from './AnimatedTransform'
import { AnimatedStyle, AnimatedObject } from '@react-spring/animated'
import { createStringInterpolator } from '@react-spring/shared/stringInterpolation'
import { is, Globals } from '@react-spring/shared'
import colorNames from '@react-spring/shared/colors'

Globals.assign({
  defaultElement: View,
  colorNames,
  createStringInterpolator,
  applyAnimatedValues: (instance, props) =>
    instance.setNativeProps ? instance.setNativeProps(props) : false,
  createAnimatedTransform: transform => new AnimatedTransform(transform),
  createAnimatedStyle(styles) {
    styles = StyleSheet.flatten(styles)
    if (is.obj(styles.shadowOffset)) {
      styles.shadowOffset = new AnimatedObject(styles.shadowOffset)
    }
    return new AnimatedStyle(styles)
  },
})

export * from './animated'
export * from '@react-spring/core'
